# @callstack/repack

## Table of contents

### Namespaces

- [Federated](modules/Federated.md)
- [plugins](modules/plugins.md)

### Other Classes

- [ConsoleReporter](classes/ConsoleReporter.md)
- [FileReporter](classes/FileReporter.md)

### Webpack Plugin Classes

- [RepackPlugin](classes/RepackPlugin.md)

### Interfaces

- [BundleArguments](interfaces/BundleArguments.md)
- [CliOptions](interfaces/CliOptions.md)
- [CommonArguments](interfaces/CommonArguments.md)
- [ConsoleReporterConfig](interfaces/ConsoleReporterConfig.md)
- [DevServerOptions](interfaces/DevServerOptions.md)
- [Fallback](interfaces/Fallback.md)
- [FileReporterConfig](interfaces/FileReporterConfig.md)
- [GetPublicPathOptions](interfaces/GetPublicPathOptions.md)
- [HMRMessage](interfaces/HMRMessage.md)
- [HMRMessageBody](interfaces/HMRMessageBody.md)
- [InitializationEntriesOptions](interfaces/InitializationEntriesOptions.md)
- [LogEntry](interfaces/LogEntry.md)
- [RepackPluginConfig](interfaces/RepackPluginConfig.md)
- [Reporter](interfaces/Reporter.md)
- [StartArguments](interfaces/StartArguments.md)
- [WebpackEnvOptions](interfaces/WebpackEnvOptions.md)
- [WebpackPlugin](interfaces/WebpackPlugin.md)

### Type Aliases

- [LogType](types/LogType.md)
- [Rule](types/Rule.md)
- [WebpackLogger](types/WebpackLogger.md)

### Variables

- [ASSET\_EXTENSIONS](variables/ASSET_EXTENSIONS.md)
- [SCALABLE\_ASSETS](variables/SCALABLE_ASSETS.md)

### CLI command Functions

- [bundle](functions/bundle.md)
- [start](functions/start.md)

### Other Functions

- [adaptFilenameToPlatform](functions/adaptFilenameToPlatform.md)
- [composeReporters](functions/composeReporters.md)
- [getAssetExtensionsRegExp](functions/getAssetExtensionsRegExp.md)
- [getWebpackEnvOptions](functions/getWebpackEnvOptions.md)
- [makeLogEntryFromFastifyLog](functions/makeLogEntryFromFastifyLog.md)

### Webpack util Functions

- [getDirname](functions/getDirname.md)
- [getInitializationEntries](functions/getInitializationEntries.md)
- [getPublicPath](functions/getPublicPath.md)
- [getResolveOptions](functions/getResolveOptions.md)
