# Interface: NormalizedScriptLocator

Internal representation of script locator data.

**`internal`**

## Table of contents

### Properties

- [absolute](NormalizedScriptLocator.md#absolute)
- [body](NormalizedScriptLocator.md#body)
- [fetch](NormalizedScriptLocator.md#fetch)
- [headers](NormalizedScriptLocator.md#headers)
- [method](NormalizedScriptLocator.md#method)
- [query](NormalizedScriptLocator.md#query)
- [timeout](NormalizedScriptLocator.md#timeout)
- [url](NormalizedScriptLocator.md#url)

## Properties

### absolute

• **absolute**: `boolean`

Whether script's URL is an absolute FileSystem URL on a target device.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:162](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L162)

___

### body

• `Optional` **body**: `string`

Request body.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:171](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L171)

___

### fetch

• **fetch**: `boolean`

Whether to fetch script from the network or use cached one.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:156](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L156)

___

### headers

• `Optional` **headers**: `Record`<`string`, `string`\>

Request headers.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:168](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L168)

___

### method

• **method**: ``"GET"`` \| ``"POST"``

HTTP method.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:150](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L150)

___

### query

• `Optional` **query**: `string`

Query params.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:165](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L165)

___

### timeout

• **timeout**: `number`

Custom timeout for script fetch requests.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:159](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L159)

___

### url

• **url**: `string`

Path-only URL to a script's location.

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:153](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L153)
