# Interface: StorageApi

Interface for storage backend used in {@link ScriptManagerConfig}.
The interface is modelled on Async Storage from `react-native-community`.

## Table of contents

### Methods

- [getItem](StorageApi.md#getitem)
- [removeItem](StorageApi.md#removeitem)
- [setItem](StorageApi.md#setitem)

## Methods

### getItem

▸ **getItem**(`key`): `Promise`<`undefined` \| ``null`` \| `string`\>

Gets the data for the key.

#### Parameters

| Name | Type |
| :------ | :------ |
| `key` | `string` |

#### Returns

`Promise`<`undefined` \| ``null`` \| `string`\>

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:136](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L136)

___

### removeItem

▸ **removeItem**(`key`): `Promise`<`void`\>

Removes the item based on the key.

#### Parameters

| Name | Type |
| :------ | :------ |
| `key` | `string` |

#### Returns

`Promise`<`void`\>

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:140](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L140)

___

### setItem

▸ **setItem**(`key`, `value`): `Promise`<`void`\>

Sets the item value based on the key.

#### Parameters

| Name | Type |
| :------ | :------ |
| `key` | `string` |
| `value` | `string` |

#### Returns

`Promise`<`void`\>

#### Defined in

[packages/repack/src/modules/ScriptManager/types.ts:138](https://github.com/callstack/repack/blob/9e6a11a/packages/repack/src/modules/ScriptManager/types.ts#L138)
